## mathcomp 1.5

=== Makefile ===
# -j2 causes a bug in caml compiler, I believe while accessing/creating the
# same file in parallel 
MAKEFLAGS := -r #-j2

.SUFFIXES:

.PHONY: clean all tags install

VERSION := 1.5
COQMAKEFILE := Makefile.coq
COQMAKE := +$(MAKE) -f $(COQMAKEFILE)
ARCHIVE := mathcomp
ifneq "$(COQBIN)" ""
	COQBIN := $(COQBIN)/
endif

all: $(COQMAKEFILE)
	mkdir -p bin
	$(COQMAKE) all

$(COQMAKEFILE): Make
	$(COQBIN)coq_makefile -f Make  > $(COQMAKEFILE)

tags:
	$(COQBIN)coqtags `find . -name \*.v`

doc:
	PATH="$(COQBIN):$$PATH" \
	     sh -c '. extra/builddoc_lib.sh; mangle_sources theories/*.v'
	$(MAKE) all
	PATH="$(COQBIN):$$PATH" TITLE="Mathematical Components" MAKEDOT=extra/ \
	COQOPTS="-R theories MathComp" \
	COQDOCOPTS="--external http://ssr.msr-inria.inria.fr/doc/ssreflect-$(VERSION) Ssreflect" \
	MANGLEDOT="sed -i s?URL=\"./?URL=\"MathComp.?"\
	      sh -c '. extra/builddoc_lib.sh; build_doc theories/*.v'
	cp extra/*.css extra/*.png html/

install:
	$(COQMAKE) install

clean:
	-$(COQMAKE) clean
	rm -f $(COQMAKEFILE)
	rm -rf $(ARCHIVE)-$(VERSION) $(ARCHIVE)-$(VERSION).tar.gz
	rm -rf test-dist

dist:
	# fill in
	rm -rf $(ARCHIVE)-$(VERSION)
	mkdir -p $(ARCHIVE)-$(VERSION)/theories/
	for f in `cat Make|grep '\.v *$$'`; do \
		cp ../`basename $$f` $(ARCHIVE)-$(VERSION)/theories/;\
	done
	cp AUTHORS CeCILL-B INSTALL Make Makefile README $(ARCHIVE)-$(VERSION)/
	# handling of NOTICE: All rights reserved -> released under XYZ
	for X in `find $(ARCHIVE)-$(VERSION)/ -name \*.v`; do\
		( head -1 $$X | grep -q 'All rights reserved' ) || \
			echo "warning: `basename $$X` with no reserved"\
		       		"copyrights";\
		sed -i -e '1rNOTICE' -e '/All rights reserved/D' $$X;\
	done
	# extra
	mkdir -p $(ARCHIVE)-$(VERSION)/extra/
	cp ../tools/hudson/builddoc_lib.sh $(ARCHIVE)-$(VERSION)/extra
	cp ../doc/makeDot/dependtodot.ml $(ARCHIVE)-$(VERSION)/extra/
	cp ../tools/coqdoc.css $(ARCHIVE)-$(VERSION)/extra/
	cp ../doc/misc/jc.png $(ARCHIVE)-$(VERSION)/extra/
	# tarball + MANIFEST
	tar -cvf $(ARCHIVE)-$(VERSION).tar $(ARCHIVE)-$(VERSION)/ | \
	  sed 's/^[^\/]*\///' | grep -v '^$$' | grep -v '/$$' |\
	       	sort > MANIFEST
	mv MANIFEST $(ARCHIVE)-$(VERSION)/MANIFEST
	tar -f $(ARCHIVE)-$(VERSION).tar -r $(ARCHIVE)-$(VERSION)/MANIFEST
	gzip -f9 $(ARCHIVE)-$(VERSION).tar
	rm -rf $(ARCHIVE)-$(VERSION)/
	mv $(ARCHIVE)-$(VERSION).tar.gz ..

test-dist:
	rm -rf test-dist
	mkdir test-dist
	tar -xzf $(ARCHIVE)-$(VERSION).tar.gz -C test-dist
	make -C test-dist/$(ARCHIVE)-$(VERSION) all install
	rm -rf test-dist

=== debian/changelog ===
mathcomp (1.5-4build1) xenial; urgency=medium

  * No-change rebuild against new coq

 -- Iain Lane <iain@orangesquash.org.uk>  Thu, 12 Nov 2015 12:11:34 +0000

mathcomp (1.5-4) unstable; urgency=medium

  * Team upload
  * Recompile with OCaml 4.02.3

 -- Stéphane Glondu <glondu@debian.org>  Sat, 17 Oct 2015 10:58:44 +0200

mathcomp (1.5-3) unstable; urgency=medium

  * Team upload
  * Recompile with coq 8.4pl4

 -- Stéphane Glondu <glondu@debian.org>  Mon, 04 Aug 2014 09:02:22 +0200

mathcomp (1.5-2) unstable; urgency=medium

  * Add dependency over libssreflect-coq (Closes: #742105) 

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 19 Mar 2014 15:03:48 +0100

mathcomp (1.5-1) unstable; urgency=medium

  * Fix copyright file (I'm the packager, even if I've copied much from
    the ssreflect package Stephane made). 
  * Initial package (Closes: #741345)

 -- Enrico Tassi <gareuselesinge@debian.org>  Tue, 11 Mar 2014 14:30:20 +0100

=== debian/control ===
Source: mathcomp
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Enrico Tassi <gareuselesinge@debian.org>
Build-Depends:
 debhelper (>= 8),
 coq (>= 8.4),
 libssreflect-coq (>= 1.5)
Standards-Version: 3.9.5
Section: math
Homepage: http://www.msr-inria.fr/projects/mathematical-components/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/mathcomp.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/mathcomp.git

Package: libmathcomp-coq
Architecture: all
Depends:
 libssreflect-coq (>= 1.5), libssreflect-coq (<< 1.6),
 coq-${F:CoqABI},
 ${misc:Depends}
Description: Mathematical Components library for Coq (theories)
 The Mathematical Components library is an extensive library of
 formalized mathematics built using the Ssreflect extension for
 the Coq system.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/coq/coqvars.mk

export COQTOP := $(COQ_STDLIB_DIR)
export COQLIB := $(COQ_STDLIB_DIR)
export COQBIN := /usr/bin/

PACKAGES := $(shell dh_listpackages)

INSTALL_DIR := $(CURDIR)/debian/tmp/usr/lib/coq/user-contrib/MathComp

%:
	+dh $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) -j2
	$(MAKE) -f Makefile.coq html

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) install DSTROOT=$(CURDIR)/debian/tmp

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

.PHONY: override_dh_clean
override_dh_clean:
	dh_clean
	rm -Rf html

.PHONY: override_dh_gencontrol
override_dh_gencontrol:
	dh_gencontrol -- -VF:CoqABI="$(COQ_ABI)"

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)(rc\d*)$/$1~$2/ \
http://ssr.msr-inria.inria.fr/FTP/ \
(?:|.*/)mathcomp(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
